package control;
import atletigui.AtletiConsoleView;
import java.io.File;
import model.*;

/**
 * Classe con strumenti per caricare i dati di atleti
 * @author Gianni
 */
public class AtletiFiller {
  
  /**
   * popola la squadra con dei dati fissati nel metodo
   * @return la squadra popolata
   */
  public static SquadraDiAtleti popolaAtleti(){
    SquadraDiAtleti atleti;
    atleti=new SquadraDiAtleti(3);
    atleti.setAtleta(0, new Atleta(12,"Rossi Mario",98.3));
    atleti.setAtleta(1, new Atleta(23,"Rossi Antonio",99.9));
    atleti.setAtleta(2, new Atleta(34,"Rossi Giada",87.65));
    return atleti;
  }
    
  /**
   * popola la squadra con i dati presenti nel file passato
   * @param f
   * @param console console su cui emettere msg di errore
   * @return la squadra popolata
   * @throws Exception errore nei dati del file
   */
  public static SquadraDiAtleti popolaAtletiViaFile(File f, AtletiConsoleView console) throws Exception {
    SquadraDiAtleti atleti;
    AtletiFileLettore lettoreAtleti;
    //apro il file
    try {
      lettoreAtleti = new AtletiFileLettore(f);
    }
    catch (Exception e) {
      // errore in apertura, sollevo eccezione
      console.scrivi("Eccezione: "+e);
      throw new Exception("Errore in apertura file");
    }
    // apertura corretta, preseguo con lettura
    //per istanziare la quadra devo sapere a priori quanti atleti
    int numAtleti=lettoreAtleti.quanteLinee()/3;
    atleti=new SquadraDiAtleti(numAtleti);
    //controllo la lettura con ciclo sul numero di atleti
    for (int i =0; i< numAtleti ; i++ ){
      //leggi il prossimo atleta: tre letture
      int pettorale;
      String cn;
      double peso;
      //leggi pettorale
      try {
        pettorale=lettoreAtleti.getPettorale();
      }
      catch (Exception e) {
        console.scrivi("Eccezione in lettura file, atleta "+i+" (pettorale) -> "+e);
        throw new Exception("Errore lettura di pettorale da file per atleta numero "+i);
      }
      //leggi cognome nome
      try {
        cn=lettoreAtleti.getCognomeNome();
      }
      catch (Exception e) {
        console.scrivi("Eccezione in lettura file, atleta "+i+" (cognomeNome) -> "+e);
        throw new Exception("Errore lettura di cognomeNome da file per atleta numero "+i);
      }
      //leggi peso
      try {
        peso=lettoreAtleti.getPeso();
      }
      catch (Exception e) {
        console.scrivi("Eccezione in lettura file, atleta "+i+" (peso) -> "+e);
        throw new Exception("Errore lettura di peso da file per atleta numero "+i);
      }
      //dati di atleta completi, istanzio oggetto
      atleti.setAtleta(i, new Atleta(pettorale,cn,peso));
    }
    //lettura completa
    return atleti;
  }
  
  
}
