package model;
import java.io.File;
import java.util.Scanner;

/**
 * Gestione dei dati di atleti su file di testo che prevede in successione:
 *   - intero per pettorale
 *   - string per neme e cognome
 *   - double per peso
 * @author Gianni
 */
public class AtletiFileLettore {
  protected File f;
  protected Scanner lettore;
  /**
   * Costruttore
   * @param f oggetto di riferimento al file dei dati
   * @throws Exception fallimento di apertura
   */
  public AtletiFileLettore(File f) throws Exception {
    this.f=f;
    lettore= new Scanner(f);
  }
  
  /**
   * lettura dell'intero del pettorale
   * @return il dato letto
   * @throws java.lang.NumberFormatException dato non conforme all'atteso
   */  
  public int getPettorale() throws java.lang.NumberFormatException {
    return Integer.parseInt(lettore.nextLine());
  }

  /**
   * lettura del double del peso
   * @return il dato letto
   * @throws java.lang.NumberFormatException dato non conforme all'atteso
   */
  public double getPeso() throws java.lang.NumberFormatException {
    return Double.parseDouble(lettore.nextLine());
  }

  /**
   * lettura della stringa cognome e nome
   * @return il dato letto
   */
  public String getCognomeNome() {
    return lettore.nextLine();
  }
  
  /**
   * tes sulla disponibilità di altri dati
   * @return true se esistono ancora dati
   */
  public boolean ancoraDati(){
    return lettore.hasNext();
  }
  
  /**
   * conta il numero di linee presenti nel file
   * @return il numero di linee
   */
  public int quanteLinee(){
    try {
      Scanner l = new Scanner(f);
      int i = 0;
      while (l.hasNext()){
        l.nextLine();
        i++;
      }
      return i;
    }
    catch (Exception e){
      return 0;  
    }
    
  }
  
}
