package model;

/**
 * Gestione dei dati di una sqiadra di atleti
 * @author Gianni
 */
public class SquadraDiAtleti {
  private Atleta[] squadra;

  /**
   * Costruttore, istanzia la squadra su un numero fornito di atleti
   * @param numAtleti il numero di altleti su cui dimensionare
   */
  public SquadraDiAtleti(int numAtleti) {
    squadra = new Atleta[numAtleti];
  }

  /**
   * Costruttore, referenzia un array di atleti passato
   * @param squadra array da referenziare
   */
  public SquadraDiAtleti(Atleta[] squadra) {
    this.squadra=squadra;
  }
  
  /**
   * setter dell'atleta di indice i
   * @param i indice, non viene testato il fuori range 
   * @param a atleta da referenziare
   */
  public void setAtleta(int i, Atleta a){
    squadra[i]=a;
  }
  
  /**
   * getter dell'atleta di indice i
   * @param i indice, non viene testato il fuori range
   * @return atleta
   */
  public Atleta getAtleta(int i){
    return squadra[i];
  }

  /**
   * Conversione a string dei dati di un atleta
   * @return dati dell'atleta
   */
  @Override
  public String toString() {
    String out="";
    
    out += "SquadraDiAtleti{" + "\nlunghezza=" + squadra.length;
    for (int i = 0; i<squadra.length ; i++){
      out += "\natleta["+i+"]="+squadra[i]+";";
    }
    out+=  "\n}\n";
    return out;
  }
  
  /**
   * Ricerca nei dati l'atleta corrispondente al numero di pettorale passato
   * @param pettorale da ricercare
   * @return atleta trovato
   * @throws Exception non esiste il pettorale ricercato
   */
  public Atleta ricercaPettorale(int pettorale) throws Exception{
    for (int i = 0; i<squadra.length ; i++){
      if (squadra[i].getPettorale()==pettorale){
        return squadra[i];
      }
    }
    throw new Exception();
  }
  
  public int getNumeroAtleti(){
      return squadra.length;
  }
}
